/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.277 Revision 1.363
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.277 2007/04/06 11:43:30 carlo Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.363 2011/09/12 20:44:01 mgorny Exp $
4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
4# 14#
5# This eclass is for general purpose functions that most ebuilds 15# Due to the nature of this eclass, some functions may have maintainers
6# have to implement themselves. 16# different from the overall eclass!
7#
8# NB: If you add anything, please comment it!
9#
10# Maintainer: see each individual function, base-system@gentoo.org as default
11 17
12inherit multilib portability 18inherit multilib portability
13 19
14DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
15 21
16# Wait for the supplied number of seconds. If no argument is supplied, defaults 22if has "${EAPI:-0}" 0 1 2; then
17# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 23
18# outputting to a terminal, don't wait. For compatability purposes, the argument 24# @FUNCTION: epause
19# must be an integer greater than zero. 25# @USAGE: [seconds]
20# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 26# @DESCRIPTION:
27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
28# printing a message the user should probably be reading and often used in
29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
30# don't wait at all. Defined in EAPIs 0 1 and 2.
21epause() { 31epause() {
22 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
23} 33}
24 34
25# Beep the specified number of times (defaults to five). If our output 35# @FUNCTION: ebeep
26# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 36# @USAGE: [number of beeps]
27# don't beep. 37# @DESCRIPTION:
28# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 38# Issue the specified number of beeps (default of 5 beeps). Useful when
39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
29ebeep() { 42ebeep() {
30 local n 43 local n
31 if [[ -z ${EBEEP_IGNORE} ]] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
32 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
33 echo -ne "\a" 46 echo -ne "\a"
36 sleep 1 49 sleep 1
37 done 50 done
38 fi 51 fi
39} 52}
40 53
41# This function generate linker scripts in /usr/lib for dynamic 54else
42# libs in /lib. This is to fix linking problems when you have 55
43# the .so in /lib, and the .a in /usr/lib. What happens is that 56ebeep() {
44# in some cases when linking dynamic, the .a in /usr/lib is used 57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
45# instead of the .so in /lib due to gcc/libtool tweaking ld's 58}
46# library search path. This cause many builds to fail. 59
47# See bug #4411 for more info. 60epause() {
48# 61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
49# To use, simply call: 62}
50# 63
51# gen_usr_ldscript libfoo.so
52#
53# Note that you should in general use the unversioned name of
54# the library, as ldconfig should usually update it correctly
55# to point to the latest version of the library present.
56#
57# <azarah@gentoo.org> (26 Oct 2002)
58#
59gen_usr_ldscript() {
60 if [[ $(type -t _tc_gen_usr_ldscript) == "function" ]] ; then
61 _tc_gen_usr_ldscript "$@"
62 return $?
63 fi 64fi
64 65
65 ewarn "QA Notice: Please upgrade your ebuild to use toolchain-funcs" 66# @FUNCTION: eqawarn
66 ewarn "QA Notice: rather than gen_usr_ldscript() from eutils" 67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
70# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
71# profile.
72if ! declare -F eqawarn >/dev/null ; then
73 eqawarn() {
74 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
75 }
76fi
67 77
68 local lib libdir=$(get_libdir) 78# @FUNCTION: ecvs_clean
69 # Just make sure it exists 79# @USAGE: [list of dirs]
70 dodir /usr/${libdir} 80# @DESCRIPTION:
81# Remove CVS directories recursiveley. Useful when a source tarball contains
82# internal CVS directories. Defaults to $PWD.
83ecvs_clean() {
84 [[ -z $* ]] && set -- .
85 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
86 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
87}
71 88
72 for lib in "${@}" ; do 89# @FUNCTION: esvn_clean
73 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 90# @USAGE: [list of dirs]
74 /* GNU ld script 91# @DESCRIPTION:
75 Since Gentoo has critical dynamic libraries 92# Remove .svn directories recursiveley. Useful when a source tarball contains
76 in /lib, and the static versions in /usr/lib, 93# internal Subversion directories. Defaults to $PWD.
77 we need to have a "fake" dynamic lib in /usr/lib, 94esvn_clean() {
78 otherwise we run into linking problems. 95 [[ -z $* ]] && set -- .
96 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
97}
79 98
80 See bug http://bugs.gentoo.org/4411 for more info. 99# @FUNCTION: eshopts_push
81 */ 100# @USAGE: [options to `set` or `shopt`]
82 GROUP ( /${libdir}/${lib} ) 101# @DESCRIPTION:
83 END_LDSCRIPT 102# Often times code will want to enable a shell option to change code behavior.
84 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 103# Since changing shell options can easily break other pieces of code (which
104# assume the default state), eshopts_push is used to (1) push the current shell
105# options onto a stack and (2) pass the specified arguments to set.
106#
107# If the first argument is '-s' or '-u', we assume you want to call `shopt`
108# rather than `set` as there are some options only available via that.
109#
110# A common example is to disable shell globbing so that special meaning/care
111# may be used with variables/arguments to custom functions. That would be:
112# @CODE
113# eshopts_push -o noglob
114# for x in ${foo} ; do
115# if ...some check... ; then
116# eshopts_pop
117# return 0
118# fi
85 done 119# done
120# eshopts_pop
121# @CODE
122eshopts_push() {
123 # have to assume __ESHOPTS_SAVE__ isn't screwed with
124 # as a `declare -a` here will reset its value
125 local i=${#__ESHOPTS_SAVE__[@]}
126 if [[ $1 == -[su] ]] ; then
127 __ESHOPTS_SAVE__[$i]=$(shopt -p)
128 [[ $# -eq 0 ]] && return 0
129 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
130 else
131 __ESHOPTS_SAVE__[$i]=$-
132 [[ $# -eq 0 ]] && return 0
133 set "$@" || die "eshopts_push: bad options to set: $*"
134 fi
86} 135}
87 136
137# @FUNCTION: eshopts_pop
138# @USAGE:
139# @DESCRIPTION:
140# Restore the shell options to the state saved with the corresponding
141# eshopts_push call. See that function for more details.
142eshopts_pop() {
143 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
144 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
145 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
146 local s=${__ESHOPTS_SAVE__[$i]}
147 unset __ESHOPTS_SAVE__[$i]
148 if [[ ${s} == "shopt -"* ]] ; then
149 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
150 else
151 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
152 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
153 fi
154}
88 155
89# Default directory where patches are located 156# @VARIABLE: EPATCH_SOURCE
157# @DESCRIPTION:
158# Default directory to search for patches.
90EPATCH_SOURCE="${WORKDIR}/patch" 159EPATCH_SOURCE="${WORKDIR}/patch"
91# Default extension for patches 160# @VARIABLE: EPATCH_SUFFIX
161# @DESCRIPTION:
162# Default extension for patches (do not prefix the period yourself).
92EPATCH_SUFFIX="patch.bz2" 163EPATCH_SUFFIX="patch.bz2"
164# @VARIABLE: EPATCH_OPTS
165# @DESCRIPTION:
93# Default options for patch 166# Default options for patch:
167# @CODE
94# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 168# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
95# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 169# --no-backup-if-mismatch - do not leave .orig files behind
96# Set -E to automatically remove empty files. 170# -E - automatically remove empty files
171# @CODE
97EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 172EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
173# @VARIABLE: EPATCH_EXCLUDE
174# @DESCRIPTION:
98# List of patches not to apply. Not this is only file names, 175# List of patches not to apply. Note this is only file names,
99# and not the full path .. 176# and not the full path. Globs accepted.
100EPATCH_EXCLUDE="" 177EPATCH_EXCLUDE=""
178# @VARIABLE: EPATCH_SINGLE_MSG
179# @DESCRIPTION:
101# Change the printed message for a single patch. 180# Change the printed message for a single patch.
102EPATCH_SINGLE_MSG="" 181EPATCH_SINGLE_MSG=""
182# @VARIABLE: EPATCH_MULTI_MSG
183# @DESCRIPTION:
103# Change the printed message for multiple patches. 184# Change the printed message for multiple patches.
104EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 185EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
105# Force applying bulk patches even if not following the style: 186# @VARIABLE: EPATCH_FORCE
106# 187# @DESCRIPTION:
107# ??_${ARCH}_foo.${EPATCH_SUFFIX} 188# Only require patches to match EPATCH_SUFFIX rather than the extended
108# 189# arch naming style.
109EPATCH_FORCE="no" 190EPATCH_FORCE="no"
110 191
111# This function is for bulk patching, or in theory for just one 192# @FUNCTION: epatch
112# or two patches. 193# @USAGE: [patches] [dirs of patches]
194# @DESCRIPTION:
195# epatch is designed to greatly simplify the application of patches. It can
196# process patch files directly, or directories of patches. The patches may be
197# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
198# the -p option as epatch will automatically attempt -p0 to -p5 until things
199# apply successfully.
113# 200#
114# It should work with .bz2, .gz, .zip and plain text patches. 201# If you do not specify any options, then epatch will default to the directory
115# Currently all patches should be the same format. 202# specified by EPATCH_SOURCE.
116# 203#
117# You do not have to specify '-p' option to patch, as it will 204# When processing directories, epatch will apply all patches that match:
118# try with -p0 to -p5 until it succeed, or fail at -p5. 205# @CODE
119# 206# if ${EPATCH_FORCE} != "yes"
120# Above EPATCH_* variables can be used to control various defaults,
121# bug they should be left as is to ensure an ebuild can rely on
122# them for.
123#
124# Patches are applied in current directory.
125#
126# Bulk Patches should preferibly have the form of:
127#
128# ??_${ARCH}_foo.${EPATCH_SUFFIX} 207# ??_${ARCH}_foo.${EPATCH_SUFFIX}
208# else
209# *.${EPATCH_SUFFIX}
210# @CODE
211# The leading ?? are typically numbers used to force consistent patch ordering.
212# The arch field is used to apply patches only for the host architecture with
213# the special value of "all" means apply for everyone. Note that using values
214# other than "all" is highly discouraged -- you should apply patches all the
215# time and let architecture details be detected at configure/compile time.
129# 216#
130# For example: 217# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
218# for patches to apply.
131# 219#
132# 01_all_misc-fix.patch.bz2 220# Refer to the other EPATCH_xxx variables for more customization of behavior.
133# 02_sparc_another-fix.patch.bz2
134#
135# This ensures that there are a set order, and you can have ARCH
136# specific patches.
137#
138# If you however give an argument to epatch(), it will treat it as a
139# single patch that need to be applied if its a file. If on the other
140# hand its a directory, it will set EPATCH_SOURCE to this.
141#
142# <azarah@gentoo.org> (10 Nov 2002)
143#
144epatch() { 221epatch() {
145 _epatch_draw_line() { 222 _epatch_draw_line() {
223 # create a line of same length as input string
146 [[ -z $1 ]] && set "$(printf "%65s" '')" 224 [[ -z $1 ]] && set "$(printf "%65s" '')"
147 echo "${1//?/=}" 225 echo "${1//?/=}"
148 } 226 }
149 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
150 local PIPE_CMD=""
151 local STDERR_TARGET="${T}/$$.out"
152 local PATCH_TARGET="${T}/$$.patch"
153 local PATCH_SUFFIX=""
154 local SINGLE_PATCH="no"
155 local x=""
156 227
157 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 228 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
158 229
159 if [ "$#" -gt 1 ] 230 # Let the rest of the code process one user arg at a time --
160 then 231 # each arg may expand into multiple patches, and each arg may
232 # need to start off with the default global EPATCH_xxx values
233 if [[ $# -gt 1 ]] ; then
161 local m="" 234 local m
162 for m in "$@" ; do 235 for m in "$@" ; do
163 epatch "${m}" 236 epatch "${m}"
164 done 237 done
165 return 0 238 return 0
166 fi 239 fi
167 240
168 if [ -n "$1" -a -f "$1" ] 241 local SINGLE_PATCH="no"
169 then 242 # no args means process ${EPATCH_SOURCE}
243 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
244
245 if [[ -f $1 ]] ; then
170 SINGLE_PATCH="yes" 246 SINGLE_PATCH="yes"
171 247 set -- "$1"
172 local EPATCH_SOURCE="$1" 248 # Use the suffix from the single patch (localize it); the code
249 # below will find the suffix for us
173 local EPATCH_SUFFIX="${1##*\.}" 250 local EPATCH_SUFFIX=$1
174 251
175 elif [ -n "$1" -a -d "$1" ] 252 elif [[ -d $1 ]] ; then
176 then 253 # Some people like to make dirs of patches w/out suffixes (vim)
177 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 254 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
178 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 255
256 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
257 # Re-use EPATCH_SOURCE as a search dir
258 epatch "${EPATCH_SOURCE}/$1"
259 return $?
260
261 else
262 # sanity check ... if it isn't a dir or file, wtf man ?
263 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
264 echo
265 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
266 eerror
267 eerror " ${EPATCH_SOURCE}"
268 eerror " ( ${EPATCH_SOURCE##*/} )"
269 echo
270 die "Cannot find \$EPATCH_SOURCE!"
271 fi
272
273 local PIPE_CMD
274 case ${EPATCH_SUFFIX##*\.} in
275 xz) PIPE_CMD="xz -dc" ;;
276 lzma) PIPE_CMD="lzma -dc" ;;
277 bz2) PIPE_CMD="bzip2 -dc" ;;
278 gz|Z|z) PIPE_CMD="gzip -dc" ;;
279 ZIP|zip) PIPE_CMD="unzip -p" ;;
280 *) ;;
281 esac
282
283 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
284
285 local x
286 for x in "$@" ; do
287 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
288 # didn't match anything, ignore continue on
289 [[ ! -f ${x} ]] && continue
290
291 local patchname=${x##*/}
292
293 # Apply single patches, or forced sets of patches, or
294 # patches with ARCH dependant names.
295 # ???_arch_foo.patch
296 # Else, skip this input altogether
297 local a=${patchname#*_} # strip the ???_
298 a=${a%%_*} # strip the _foo.patch
299 if ! [[ ${SINGLE_PATCH} == "yes" || \
300 ${EPATCH_FORCE} == "yes" || \
301 ${a} == all || \
302 ${a} == ${ARCH} ]]
179 then 303 then
180 local EPATCH_SOURCE="$1/*" 304 continue
305 fi
306
307 # Let people filter things dynamically
308 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
309 # let people use globs in the exclude
310 eshopts_push -o noglob
311
312 local ex
313 for ex in ${EPATCH_EXCLUDE} ; do
314 if [[ ${patchname} == ${ex} ]] ; then
315 eshopts_pop
316 continue 2
317 fi
318 done
319
320 eshopts_pop
321 fi
322
323 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
324 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
325 einfo "${EPATCH_SINGLE_MSG}"
326 else
327 einfo "Applying ${patchname} ..."
328 fi
181 else 329 else
182 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 330 einfo " ${patchname} ..."
183 fi 331 fi
184 else 332
185 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 333 # most of the time, there will only be one run per unique name,
186 then 334 # but if there are more, make sure we get unique log filenames
187 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 335 local STDERR_TARGET="${T}/${patchname}.out"
188 then 336 if [[ -e ${STDERR_TARGET} ]] ; then
189 EPATCH_SOURCE="$1" 337 STDERR_TARGET="${T}/${patchname}-$$.out"
338 fi
339
340 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
341
342 # Decompress the patch if need be
343 local count=0
344 local PATCH_TARGET
345 if [[ -n ${PIPE_CMD} ]] ; then
346 PATCH_TARGET="${T}/$$.patch"
347 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
348
349 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
350 echo
351 eerror "Could not extract patch!"
352 #die "Could not extract patch!"
353 count=5
354 break
190 fi 355 fi
356 else
357 PATCH_TARGET=${x}
358 fi
191 359
360 # Check for absolute paths in patches. If sandbox is disabled,
361 # people could (accidently) patch files in the root filesystem.
362 # Or trigger other unpleasantries #237667. So disallow -p0 on
363 # such patches.
364 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
365 if [[ -n ${abs_paths} ]] ; then
366 count=1
367 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
368 fi
369 # Similar reason, but with relative paths.
370 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
371 if [[ -n ${rel_paths} ]] ; then
372 eqawarn "QA Notice: Your patch uses relative paths '../'."
373 eqawarn " In the future this will cause a failure."
374 eqawarn "${rel_paths}"
375 fi
376
377 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
378 while [[ ${count} -lt 5 ]] ; do
379 # Generate some useful debug info ...
380 (
381 _epatch_draw_line "***** ${patchname} *****"
192 echo 382 echo
193 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 383 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
384 echo
385 _epatch_draw_line "***** ${patchname} *****"
386 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
387 ret=$?
388 echo
389 echo "patch program exited with status ${ret}"
390 exit ${ret}
391 ) >> "${STDERR_TARGET}"
392
393 if [ $? -eq 0 ] ; then
394 (
395 _epatch_draw_line "***** ${patchname} *****"
396 echo
397 echo "ACTUALLY APPLYING ${patchname} ..."
398 echo
399 _epatch_draw_line "***** ${patchname} *****"
400 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
401 ret=$?
402 echo
403 echo "patch program exited with status ${ret}"
404 exit ${ret}
405 ) >> "${STDERR_TARGET}"
406
407 if [ $? -ne 0 ] ; then
408 echo
409 eerror "A dry-run of patch command succeeded, but actually"
410 eerror "applying the patch failed!"
411 #die "Real world sux compared to the dreamworld!"
412 count=5
413 fi
414 break
415 fi
416
417 : $(( count++ ))
418 done
419
420 # if we had to decompress the patch, delete the temp one
421 if [[ -n ${PIPE_CMD} ]] ; then
422 rm -f "${PATCH_TARGET}"
423 fi
424
425 if [[ ${count} -ge 5 ]] ; then
426 echo
427 eerror "Failed Patch: ${patchname} !"
428 eerror " ( ${PATCH_TARGET} )"
194 eerror 429 eerror
195 eerror " ${EPATCH_SOURCE}" 430 eerror "Include in your bugreport the contents of:"
196 eerror " ( ${EPATCH_SOURCE##*/} )" 431 eerror
432 eerror " ${STDERR_TARGET}"
197 echo 433 echo
198 die "Cannot find \$EPATCH_SOURCE!"
199 fi
200
201 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
202 fi
203
204 case ${EPATCH_SUFFIX##*\.} in
205 bz2)
206 PIPE_CMD="bzip2 -dc"
207 PATCH_SUFFIX="bz2"
208 ;;
209 gz|Z|z)
210 PIPE_CMD="gzip -dc"
211 PATCH_SUFFIX="gz"
212 ;;
213 ZIP|zip)
214 PIPE_CMD="unzip -p"
215 PATCH_SUFFIX="zip"
216 ;;
217 *)
218 PIPE_CMD="cat"
219 PATCH_SUFFIX="patch"
220 ;;
221 esac
222
223 if [ "${SINGLE_PATCH}" = "no" ]
224 then
225 einfo "${EPATCH_MULTI_MSG}"
226 fi
227 for x in ${EPATCH_SOURCE}
228 do
229 # New ARCH dependant patch naming scheme ...
230 #
231 # ???_arch_foo.patch
232 #
233 if [ -f ${x} ] && \
234 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
235 [ "${EPATCH_FORCE}" = "yes" ])
236 then
237 local count=0
238 local popts="${EPATCH_OPTS}"
239 local patchname=${x##*/}
240
241 if [ -n "${EPATCH_EXCLUDE}" ]
242 then
243 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
244 then
245 continue
246 fi
247 fi
248
249 if [ "${SINGLE_PATCH}" = "yes" ]
250 then
251 if [ -n "${EPATCH_SINGLE_MSG}" ]
252 then
253 einfo "${EPATCH_SINGLE_MSG}"
254 else
255 einfo "Applying ${patchname} ..."
256 fi
257 else
258 einfo " ${patchname} ..."
259 fi
260
261 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
262 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
263
264 # Allow for prefix to differ ... im lazy, so shoot me :/
265 while [ "${count}" -lt 5 ]
266 do
267 # Generate some useful debug info ...
268 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
269 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
270
271 if [ "${PATCH_SUFFIX}" != "patch" ]
272 then
273 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
274 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
275 else
276 PATCH_TARGET="${x}"
277 fi
278
279 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
280 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
281
282 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
283 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
284
285 if [ "${PATCH_SUFFIX}" != "patch" ]
286 then
287 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
288 then
289 echo
290 eerror "Could not extract patch!"
291 #die "Could not extract patch!"
292 count=5
293 break
294 fi
295 fi
296
297 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
298 then
299 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
300 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
301 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
302 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
303 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
304
305 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
306 _epatch_assert
307
308 if [ "$?" -ne 0 ]
309 then
310 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
311 echo
312 eerror "A dry-run of patch command succeeded, but actually"
313 eerror "applying the patch failed!"
314 #die "Real world sux compared to the dreamworld!"
315 count=5
316 fi
317
318 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
319
320 break
321 fi
322
323 count=$((count + 1))
324 done
325
326 if [ "${PATCH_SUFFIX}" != "patch" ]
327 then
328 rm -f ${PATCH_TARGET}
329 fi
330
331 if [ "${count}" -eq 5 ]
332 then
333 echo
334 eerror "Failed Patch: ${patchname} !"
335 eerror " ( ${PATCH_TARGET} )"
336 eerror
337 eerror "Include in your bugreport the contents of:"
338 eerror
339 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
340 echo
341 die "Failed Patch: ${patchname}!" 434 die "Failed Patch: ${patchname}!"
342 fi 435 fi
343 436
344 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 437 # if everything worked, delete the patch log
345 438 rm -f "${STDERR_TARGET}"
346 eend 0 439 eend 0
347 fi
348 done 440 done
349 if [ "${SINGLE_PATCH}" = "no" ] 441
350 then 442 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
351 einfo "Done with patching" 443 : # everything worked
444}
445
446# @FUNCTION: epatch_user
447# @USAGE:
448# @DESCRIPTION:
449# Applies user-provided patches to the source tree. The patches are
450# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
451# of these three directories to exist will be the one to use, ignoring
452# any more general directories which might exist as well.
453#
454# User patches are intended for quick testing of patches without ebuild
455# modifications, as well as for permanent customizations a user might
456# desire. Obviously, there can be no official support for arbitrarily
457# patched ebuilds. So whenever a build log in a bug report mentions that
458# user patches were applied, the user should be asked to reproduce the
459# problem without these.
460#
461# Not all ebuilds do call this function, so placing patches in the
462# stated directory might or might not work, depending on the package and
463# the eclasses it inherits and uses. It is safe to call the function
464# repeatedly, so it is always possible to add a call at the ebuild
465# level. The first call is the time when the patches will be
466# applied.
467#
468# Ideally, this function should be called after gentoo-specific patches
469# have been applied, so that their code can be modified as well, but
470# before calls to e.g. eautoreconf, as the user patches might affect
471# autotool input files as well.
472epatch_user() {
473 [[ $# -ne 0 ]] && die "epatch_user takes no options"
474
475 # Allow multiple calls to this function; ignore all but the first
476 local applied="${T}/epatch_user.applied"
477 [[ -e ${applied} ]] && return 2
478
479 # don't clobber any EPATCH vars that the parent might want
480 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
481 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
482 EPATCH_SOURCE=${base}/${CTARGET}/${check}
483 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
484 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
485 if [[ -d ${EPATCH_SOURCE} ]] ; then
486 EPATCH_SOURCE=${EPATCH_SOURCE} \
487 EPATCH_SUFFIX="patch" \
488 EPATCH_FORCE="yes" \
489 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
490 epatch
491 echo "${EPATCH_SOURCE}" > "${applied}"
492 return 0
352 fi 493 fi
494 done
495 echo "none" > "${applied}"
496 return 1
353} 497}
354 498
499# @FUNCTION: emktemp
500# @USAGE: [temp dir]
501# @DESCRIPTION:
355# Cheap replacement for when debianutils (and thus mktemp) 502# Cheap replacement for when debianutils (and thus mktemp)
356# does not exist on the users system 503# does not exist on the users system.
357# vapier@gentoo.org
358#
359# Takes just 1 optional parameter (the directory to create tmpfile in)
360emktemp() { 504emktemp() {
361 local exe="touch" 505 local exe="touch"
362 [[ $1 == -d ]] && exe="mkdir" && shift 506 [[ $1 == -d ]] && exe="mkdir" && shift
363 local topdir=$1 507 local topdir=$1
364 508
366 [[ -z ${T} ]] \ 510 [[ -z ${T} ]] \
367 && topdir="/tmp" \ 511 && topdir="/tmp" \
368 || topdir=${T} 512 || topdir=${T}
369 fi 513 fi
370 514
371 if [[ -z $(type -p mktemp) ]] ; then 515 if ! type -P mktemp > /dev/null ; then
516 # system lacks `mktemp` so we have to fake it
372 local tmp=/ 517 local tmp=/
373 while [[ -e ${tmp} ]] ; do 518 while [[ -e ${tmp} ]] ; do
374 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 519 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
375 done 520 done
376 ${exe} "${tmp}" || ${exe} -p "${tmp}" 521 ${exe} "${tmp}" || ${exe} -p "${tmp}"
377 echo "${tmp}" 522 echo "${tmp}"
378 else 523 else
524 # the args here will give slightly wierd names on BSD,
525 # but should produce a usable file on all userlands
379 if [[ ${exe} == "touch" ]] ; then 526 if [[ ${exe} == "touch" ]] ; then
380 [[ ${USERLAND} == "GNU" ]] \
381 && mktemp -p "${topdir}" \
382 || TMPDIR="${topdir}" mktemp -t tmp 527 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
383 else 528 else
384 [[ ${USERLAND} == "GNU" ]] \
385 && mktemp -d "${topdir}" \
386 || TMPDIR="${topdir}" mktemp -dt tmp 529 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
387 fi
388 fi 530 fi
531 fi
389} 532}
390 533
534# @FUNCTION: egetent
535# @USAGE: <database> <key>
536# @MAINTAINER:
537# base-system@gentoo.org (Linux)
538# Joe Jezak <josejx@gmail.com> (OS X)
539# usata@gentoo.org (OS X)
540# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
541# @DESCRIPTION:
391# Small wrapper for getent (Linux), nidump (Mac OS X), 542# Small wrapper for getent (Linux),
543# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
392# and pw (FreeBSD) used in enewuser()/enewgroup() 544# and pw (FreeBSD) used in enewuser()/enewgroup()
393# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
394# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
395#
396# egetent(database, key)
397egetent() { 545egetent() {
398 case ${CHOST} in 546 case ${CHOST} in
399 *-darwin*) 547 *-darwin[678])
400 case "$2" in 548 case "$2" in
401 *[!0-9]*) # Non numeric 549 *[!0-9]*) # Non numeric
402 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 550 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2\$/) {print \$0;exit;} }"
403 ;; 551 ;;
404 *) # Numeric 552 *) # Numeric
405 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 553 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
554 ;;
555 esac
556 ;;
557 *-darwin*)
558 local mytype=$1
559 [[ "passwd" == $mytype ]] && mytype="Users"
560 [[ "group" == $mytype ]] && mytype="Groups"
561 case "$2" in
562 *[!0-9]*) # Non numeric
563 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
564 ;;
565 *) # Numeric
566 local mykey="UniqueID"
567 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
568 dscl . -search /$mytype $mykey $2 2>/dev/null
406 ;; 569 ;;
407 esac 570 esac
408 ;; 571 ;;
409 *-freebsd*|*-dragonfly*) 572 *-freebsd*|*-dragonfly*)
410 local opts action="user" 573 local opts action="user"
425 getent "$1" "$2" 588 getent "$1" "$2"
426 ;; 589 ;;
427 esac 590 esac
428} 591}
429 592
430# Simplify/standardize adding users to the system 593# @FUNCTION: enewuser
431# vapier@gentoo.org 594# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
432# 595# @DESCRIPTION:
433# enewuser(username, uid, shell, homedir, groups, extra options) 596# Same as enewgroup, you are not required to understand how to properly add
434# 597# a user to the system. The only required parameter is the username.
435# Default values if you do not specify any: 598# Default uid is (pass -1 for this) next available, default shell is
436# username: REQUIRED ! 599# /bin/false, default homedir is /dev/null, there are no default groups,
437# uid: next available (see useradd(8)) 600# and default params sets the comment as 'added by portage for ${PN}'.
438# note: pass -1 to get default behavior
439# shell: /bin/false
440# homedir: /dev/null
441# groups: none
442# extra: comment of 'added by portage for ${PN}'
443enewuser() { 601enewuser() {
444 case ${EBUILD_PHASE} in 602 case ${EBUILD_PHASE} in
445 unpack|compile|test|install) 603 unpack|compile|test|install)
446 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function." 604 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
447 eerror "Package fails at QA and at life. Please file a bug." 605 eerror "Package fails at QA and at life. Please file a bug."
615 fi 773 fi
616 ;; 774 ;;
617 775
618 *) 776 *)
619 if [[ -z $@ ]] ; then 777 if [[ -z $@ ]] ; then
620 useradd ${opts} ${euser} \ 778 useradd -r ${opts} \
621 -c "added by portage for ${PN}" \ 779 -c "added by portage for ${PN}" \
780 ${euser} \
622 || die "enewuser failed" 781 || die "enewuser failed"
623 else 782 else
624 einfo " - Extra: $@" 783 einfo " - Extra: $@"
625 useradd ${opts} ${euser} "$@" \ 784 useradd -r ${opts} "$@" \
785 ${euser} \
626 || die "enewuser failed" 786 || die "enewuser failed"
627 fi 787 fi
628 ;; 788 ;;
629 esac 789 esac
630 790
636 fi 796 fi
637 797
638 export SANDBOX_ON=${oldsandbox} 798 export SANDBOX_ON=${oldsandbox}
639} 799}
640 800
641# Simplify/standardize adding groups to the system 801# @FUNCTION: enewgroup
642# vapier@gentoo.org 802# @USAGE: <group> [gid]
643# 803# @DESCRIPTION:
644# enewgroup(group, gid) 804# This function does not require you to understand how to properly add a
645# 805# group to the system. Just give it a group name to add and enewgroup will
646# Default values if you do not specify any: 806# do the rest. You may specify the gid for the group or allow the group to
647# groupname: REQUIRED ! 807# allocate the next available one.
648# gid: next available (see groupadd(8))
649# extra: none
650enewgroup() { 808enewgroup() {
651 case ${EBUILD_PHASE} in 809 case ${EBUILD_PHASE} in
652 unpack|compile|test|install) 810 unpack|compile|test|install)
653 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function." 811 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
654 eerror "Package fails at QA and at life. Please file a bug." 812 eerror "Package fails at QA and at life. Please file a bug."
744 esac 902 esac
745 groupadd -g ${egid} ${egroup} || die "enewgroup failed" 903 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
746 ;; 904 ;;
747 905
748 *) 906 *)
907 # We specify -r so that we get a GID in the system range from login.defs
749 groupadd ${opts} ${egroup} || die "enewgroup failed" 908 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
750 ;; 909 ;;
751 esac 910 esac
752 export SANDBOX_ON="${oldsandbox}" 911 export SANDBOX_ON="${oldsandbox}"
753} 912}
754 913
755# Simple script to replace 'dos2unix' binaries 914# @FUNCTION: edos2unix
756# vapier@gentoo.org 915# @USAGE: <file> [more files ...]
757# 916# @DESCRIPTION:
758# edos2unix(file, <more files> ...) 917# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
918# to remove all of these text utilities from DEPEND variables because this
919# is a script based solution. Just give it a list of files to convert and
920# they will all be changed from the DOS CRLF format to the UNIX LF format.
759edos2unix() { 921edos2unix() {
760 echo "$@" | xargs sed -i 's/\r$//' 922 echo "$@" | xargs sed -i 's/\r$//'
761} 923}
762
763
764##############################################################
765# START: Handle .desktop files and menu entries #
766# maybe this should be separated into a new eclass some time #
767# lanius@gentoo.org #
768##############################################################
769 924
770# Make a desktop file ! 925# Make a desktop file !
771# Great for making those icons in kde/gnome startmenu ! 926# Great for making those icons in kde/gnome startmenu !
772# Amaze your friends ! Get the women ! Join today ! 927# Amaze your friends ! Get the women ! Join today !
773# 928#
774# make_desktop_entry(<command>, [name], [icon], [type], [path]) 929# make_desktop_entry(<command>, [name], [icon], [type], [fields])
775# 930#
776# binary: what command does the app run with ? 931# binary: what command does the app run with ?
777# name: the name that will show up in the menu 932# name: the name that will show up in the menu
778# icon: give your little like a pretty little icon ... 933# icon: give your little like a pretty little icon ...
779# this can be relative (to /usr/share/pixmaps) or 934# this can be relative (to /usr/share/pixmaps) or
780# a full path to an icon 935# a full path to an icon
781# type: what kind of application is this ? for categories: 936# type: what kind of application is this ? for categories:
782# http://www.freedesktop.org/Standards/desktop-entry-spec 937# http://standards.freedesktop.org/menu-spec/latest/apa.html
783# path: if your app needs to startup in a specific dir 938# fields: extra fields to append to the desktop file; a printf string
784make_desktop_entry() { 939make_desktop_entry() {
785 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 940 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
786 941
787 local exec=${1} 942 local exec=${1}
788 local name=${2:-${PN}} 943 local name=${2:-${PN}}
789 local icon=${3:-${PN}.png} 944 local icon=${3:-${PN}}
790 local type=${4} 945 local type=${4}
791 local path=${5} 946 local fields=${5}
792 947
793 if [[ -z ${type} ]] ; then 948 if [[ -z ${type} ]] ; then
794 local catmaj=${CATEGORY%%-*} 949 local catmaj=${CATEGORY%%-*}
795 local catmin=${CATEGORY##*-} 950 local catmin=${CATEGORY##*-}
796 case ${catmaj} in 951 case ${catmaj} in
797 app) 952 app)
798 case ${catmin} in 953 case ${catmin} in
954 accessibility) type=Accessibility;;
799 admin) type=System;; 955 admin) type=System;;
956 antivirus) type=System;;
957 arch) type=Archiving;;
958 backup) type=Archiving;;
800 cdr) type=DiscBurning;; 959 cdr) type=DiscBurning;;
801 dicts) type=Dictionary;; 960 dicts) type=Dictionary;;
961 doc) type=Documentation;;
802 editors) type=TextEditor;; 962 editors) type=TextEditor;;
803 emacs) type=TextEditor;; 963 emacs) type=TextEditor;;
804 emulation) type=Emulator;; 964 emulation) type=Emulator;;
805 laptop) type=HardwareSettings;; 965 laptop) type=HardwareSettings;;
806 office) type=Office;; 966 office) type=Office;;
967 pda) type=PDA;;
807 vim) type=TextEditor;; 968 vim) type=TextEditor;;
808 xemacs) type=TextEditor;; 969 xemacs) type=TextEditor;;
809 *) type=;;
810 esac 970 esac
811 ;; 971 ;;
812 972
813 dev) 973 dev)
814 type="Development" 974 type="Development"
815 ;; 975 ;;
816 976
817 games) 977 games)
818 case ${catmin} in 978 case ${catmin} in
819 action|fps) type=ActionGame;; 979 action|fps) type=ActionGame;;
820 arcade) type=ArcadeGame;; 980 arcade) type=ArcadeGame;;
821 board) type=BoardGame;; 981 board) type=BoardGame;;
822 kids) type=KidsGame;;
823 emulation) type=Emulator;; 982 emulation) type=Emulator;;
983 kids) type=KidsGame;;
824 puzzle) type=LogicGame;; 984 puzzle) type=LogicGame;;
825 rpg) type=RolePlaying;;
826 roguelike) type=RolePlaying;; 985 roguelike) type=RolePlaying;;
986 rpg) type=RolePlaying;;
827 simulation) type=Simulation;; 987 simulation) type=Simulation;;
828 sports) type=SportsGame;; 988 sports) type=SportsGame;;
829 strategy) type=StrategyGame;; 989 strategy) type=StrategyGame;;
830 *) type=;;
831 esac 990 esac
832 type="Game;${type}" 991 type="Game;${type}"
833 ;; 992 ;;
834 993
994 gnome)
995 type="Gnome;GTK"
996 ;;
997
998 kde)
999 type="KDE;Qt"
1000 ;;
1001
835 mail) 1002 mail)
836 type="Network;Email" 1003 type="Network;Email"
837 ;; 1004 ;;
838 1005
839 media) 1006 media)
840 case ${catmin} in 1007 case ${catmin} in
1008 gfx)
841 gfx) type=Graphics;; 1009 type=Graphics
1010 ;;
1011 *)
1012 case ${catmin} in
842 radio) type=Tuner;; 1013 radio) type=Tuner;;
843 sound) type=Audio;; 1014 sound) type=Audio;;
844 tv) type=TV;; 1015 tv) type=TV;;
845 video) type=Video;; 1016 video) type=Video;;
846 *) type=;; 1017 esac
1018 type="AudioVideo;${type}"
1019 ;;
847 esac 1020 esac
848 type="AudioVideo;${type}"
849 ;; 1021 ;;
850 1022
851 net) 1023 net)
852 case ${catmin} in 1024 case ${catmin} in
853 dialup) type=Dialup;; 1025 dialup) type=Dialup;;
854 ftp) type=FileTransfer;; 1026 ftp) type=FileTransfer;;
855 im) type=InstantMessaging;; 1027 im) type=InstantMessaging;;
856 irc) type=IRCClient;; 1028 irc) type=IRCClient;;
857 mail) type=Email;; 1029 mail) type=Email;;
858 news) type=News;; 1030 news) type=News;;
859 nntp) type=News;; 1031 nntp) type=News;;
860 p2p) type=FileTransfer;; 1032 p2p) type=FileTransfer;;
861 *) type=;; 1033 voip) type=Telephony;;
862 esac 1034 esac
863 type="Network;${type}" 1035 type="Network;${type}"
864 ;; 1036 ;;
865 1037
866 sci) 1038 sci)
867 case ${catmin} in 1039 case ${catmin} in
868 astro*) type=Astronomy;; 1040 astro*) type=Astronomy;;
869 bio*) type=Biology;; 1041 bio*) type=Biology;;
870 calc*) type=Calculator;; 1042 calc*) type=Calculator;;
871 chem*) type=Chemistry;; 1043 chem*) type=Chemistry;;
1044 elec*) type=Electronics;;
872 geo*) type=Geology;; 1045 geo*) type=Geology;;
873 math*) type=Math;; 1046 math*) type=Math;;
874 *) type=;; 1047 physics) type=Physics;;
1048 visual*) type=DataVisualization;;
875 esac 1049 esac
876 type="Science;${type}" 1050 type="Education;Science;${type}"
1051 ;;
1052
1053 sys)
1054 type="System"
877 ;; 1055 ;;
878 1056
879 www) 1057 www)
880 case ${catmin} in 1058 case ${catmin} in
881 client) type=WebBrowser;; 1059 client) type=WebBrowser;;
882 *) type=;;
883 esac 1060 esac
884 type="Network" 1061 type="Network;${type}"
885 ;; 1062 ;;
886 1063
887 *) 1064 *)
888 type= 1065 type=
889 ;; 1066 ;;
895 local desktop_name="${PN}-${SLOT}" 1072 local desktop_name="${PN}-${SLOT}"
896 fi 1073 fi
897 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 1074 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
898 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 1075 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
899 1076
1077 # Don't append another ";" when a valid category value is provided.
1078 type=${type%;}${type:+;}
1079
1080 eshopts_push -s extglob
1081 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1082 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1083 ewarn "allowed in .desktop files if the value is not an absolute path."
1084 icon=${icon%.@(xpm|png|svg)}
1085 fi
1086 eshopts_pop
1087
900 cat <<-EOF > "${desktop}" 1088 cat <<-EOF > "${desktop}"
901 [Desktop Entry] 1089 [Desktop Entry]
902 Encoding=UTF-8
903 Version=0.9.2
904 Name=${name} 1090 Name=${name}
905 Type=Application 1091 Type=Application
906 Comment=${DESCRIPTION} 1092 Comment=${DESCRIPTION}
907 Exec=${exec} 1093 Exec=${exec}
908 TryExec=${exec%% *} 1094 TryExec=${exec%% *}
909 Path=${path}
910 Icon=${icon} 1095 Icon=${icon}
911 Categories=Application;${type}; 1096 Categories=${type}
912 EOF 1097 EOF
1098
1099 if [[ ${fields:-=} != *=* ]] ; then
1100 # 5th arg used to be value to Path=
1101 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1102 fields="Path=${fields}"
1103 fi
1104 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
913 1105
914 ( 1106 (
915 # wrap the env here so that the 'insinto' call 1107 # wrap the env here so that the 'insinto' call
916 # doesn't corrupt the env of the caller 1108 # doesn't corrupt the env of the caller
917 insinto /usr/share/applications 1109 insinto /usr/share/applications
918 doins "${desktop}" 1110 doins "${desktop}"
919 ) 1111 ) || die "installing desktop file failed"
920} 1112}
921 1113
922 1114# @FUNCTION: validate_desktop_entries
923# Validatedesktop entries using desktop-file-utils 1115# @USAGE: [directories]
1116# @MAINTAINER:
924# Carsten Lohrke <carlo@gentoo.org> 1117# Carsten Lohrke <carlo@gentoo.org>
925# 1118# @DESCRIPTION:
926# Usage: validate_desktop_entries [directory ...] 1119# Validate desktop entries using desktop-file-utils
927
928validate_desktop_entries() { 1120validate_desktop_entries() {
929 if [[ -x /usr/bin/desktop-file-validate ]] ; then 1121 if [[ -x /usr/bin/desktop-file-validate ]] ; then
930 einfo "Checking desktop entry validity" 1122 einfo "Checking desktop entry validity"
931 local directories="" 1123 local directories=""
932 for d in $@ ; do 1124 for d in /usr/share/applications $@ ; do
933 directories="${directories} ${D}${d}" 1125 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
934 done 1126 done
1127 if [[ -n ${directories} ]] ; then
935 for FILE in $(find ${D}/usr/share/applications ${directories} -name "*\.desktop" \ 1128 for FILE in $(find ${directories} -name "*\.desktop" \
936 -not -path '*.hidden*' 2>/dev/null) 1129 -not -path '*.hidden*' | sort -u 2>/dev/null)
937 do 1130 do
938 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:") 1131 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
1132 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
939 [[ -n $temp ]] && elog ${temp//${D}/} 1133 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
940 done 1134 done
1135 fi
941 echo "" 1136 echo ""
942 else 1137 else
943 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 1138 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
944 fi 1139 fi
945} 1140}
946 1141
947 1142# @FUNCTION: make_session_desktop
948# Make a GDM/KDM Session file 1143# @USAGE: <title> <command> [command args...]
1144# @DESCRIPTION:
1145# Make a GDM/KDM Session file. The title is the file to execute to start the
1146# Window Manager. The command is the name of the Window Manager.
949# 1147#
950# make_session_desktop(<title>, <command>) 1148# You can set the name of the file via the ${wm} variable.
951# title: File to execute to start the Window Manager
952# command: Name of the Window Manager
953
954make_session_desktop() { 1149make_session_desktop() {
955 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 1150 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
956 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 1151 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
957 1152
958 local title=$1 1153 local title=$1
959 local command=$2 1154 local command=$2
960 local desktop=${T}/${wm}.desktop 1155 local desktop=${T}/${wm:-${PN}}.desktop
1156 shift 2
961 1157
962 cat <<-EOF > "${desktop}" 1158 cat <<-EOF > "${desktop}"
963 [Desktop Entry] 1159 [Desktop Entry]
964 Encoding=UTF-8
965 Name=${title} 1160 Name=${title}
966 Comment=This session logs you into ${title} 1161 Comment=This session logs you into ${title}
967 Exec=${command} 1162 Exec=${command} $*
968 TryExec=${command} 1163 TryExec=${command}
969 Type=Application 1164 Type=XSession
970 EOF 1165 EOF
971 1166
972 ( 1167 (
973 # wrap the env here so that the 'insinto' call 1168 # wrap the env here so that the 'insinto' call
974 # doesn't corrupt the env of the caller 1169 # doesn't corrupt the env of the caller
975 insinto /usr/share/xsessions 1170 insinto /usr/share/xsessions
976 doins "${desktop}" 1171 doins "${desktop}"
977 ) 1172 )
978} 1173}
979 1174
1175# @FUNCTION: domenu
1176# @USAGE: <menus>
1177# @DESCRIPTION:
1178# Install the list of .desktop menu files into the appropriate directory
1179# (/usr/share/applications).
980domenu() { 1180domenu() {
981 ( 1181 (
982 # wrap the env here so that the 'insinto' call 1182 # wrap the env here so that the 'insinto' call
983 # doesn't corrupt the env of the caller 1183 # doesn't corrupt the env of the caller
984 local i j ret=0 1184 local i j ret=0
990 elif [[ -d ${i} ]] ; then 1190 elif [[ -d ${i} ]] ; then
991 for j in "${i}"/*.desktop ; do 1191 for j in "${i}"/*.desktop ; do
992 doins "${j}" 1192 doins "${j}"
993 ((ret+=$?)) 1193 ((ret+=$?))
994 done 1194 done
1195 else
1196 ((++ret))
995 fi 1197 fi
996 done 1198 done
997 exit ${ret} 1199 exit ${ret}
998 ) 1200 )
999} 1201}
1202
1203# @FUNCTION: newmenu
1204# @USAGE: <menu> <newname>
1205# @DESCRIPTION:
1206# Like all other new* functions, install the specified menu as newname.
1000newmenu() { 1207newmenu() {
1001 ( 1208 (
1002 # wrap the env here so that the 'insinto' call 1209 # wrap the env here so that the 'insinto' call
1003 # doesn't corrupt the env of the caller 1210 # doesn't corrupt the env of the caller
1004 insinto /usr/share/applications 1211 insinto /usr/share/applications
1005 newins "$@" 1212 newins "$@"
1006 ) 1213 )
1007} 1214}
1008 1215
1216# @FUNCTION: doicon
1217# @USAGE: <list of icons>
1218# @DESCRIPTION:
1219# Install the list of icons into the icon directory (/usr/share/pixmaps).
1220# This is useful in conjunction with creating desktop/menu files.
1009doicon() { 1221doicon() {
1010 ( 1222 (
1011 # wrap the env here so that the 'insinto' call 1223 # wrap the env here so that the 'insinto' call
1012 # doesn't corrupt the env of the caller 1224 # doesn't corrupt the env of the caller
1013 local i j ret 1225 local i j ret
1019 elif [[ -d ${i} ]] ; then 1231 elif [[ -d ${i} ]] ; then
1020 for j in "${i}"/*.png ; do 1232 for j in "${i}"/*.png ; do
1021 doins "${j}" 1233 doins "${j}"
1022 ((ret+=$?)) 1234 ((ret+=$?))
1023 done 1235 done
1236 else
1237 ((++ret))
1024 fi 1238 fi
1025 done 1239 done
1026 exit ${ret} 1240 exit ${ret}
1027 ) 1241 )
1028} 1242}
1243
1244# @FUNCTION: newicon
1245# @USAGE: <icon> <newname>
1246# @DESCRIPTION:
1247# Like all other new* functions, install the specified icon as newname.
1029newicon() { 1248newicon() {
1030 ( 1249 (
1031 # wrap the env here so that the 'insinto' call 1250 # wrap the env here so that the 'insinto' call
1032 # doesn't corrupt the env of the caller 1251 # doesn't corrupt the env of the caller
1033 insinto /usr/share/pixmaps 1252 insinto /usr/share/pixmaps
1034 newins "$@" 1253 newins "$@"
1035 ) 1254 )
1036} 1255}
1037
1038##############################################################
1039# END: Handle .desktop files and menu entries #
1040##############################################################
1041
1042 1256
1043# for internal use only (unpack_pdv and unpack_makeself) 1257# for internal use only (unpack_pdv and unpack_makeself)
1044find_unpackable_file() { 1258find_unpackable_file() {
1045 local src=$1 1259 local src=$1
1046 if [[ -z ${src} ]] ; then 1260 if [[ -z ${src} ]] ; then
1056 fi 1270 fi
1057 [[ ! -e ${src} ]] && return 1 1271 [[ ! -e ${src} ]] && return 1
1058 echo "${src}" 1272 echo "${src}"
1059} 1273}
1060 1274
1275# @FUNCTION: unpack_pdv
1276# @USAGE: <file to unpack> <size of off_t>
1277# @DESCRIPTION:
1061# Unpack those pesky pdv generated files ... 1278# Unpack those pesky pdv generated files ...
1062# They're self-unpacking programs with the binary package stuffed in 1279# They're self-unpacking programs with the binary package stuffed in
1063# the middle of the archive. Valve seems to use it a lot ... too bad 1280# the middle of the archive. Valve seems to use it a lot ... too bad
1064# it seems to like to segfault a lot :(. So lets take it apart ourselves. 1281# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1065# 1282#
1066# Usage: unpack_pdv [file to unpack] [size of off_t]
1067# - you have to specify the off_t size ... i have no idea how to extract that 1283# You have to specify the off_t size ... I have no idea how to extract that
1068# information out of the binary executable myself. basically you pass in 1284# information out of the binary executable myself. Basically you pass in
1069# the size of the off_t type (in bytes) on the machine that built the pdv 1285# the size of the off_t type (in bytes) on the machine that built the pdv
1286# archive.
1287#
1070# archive. one way to determine this is by running the following commands: 1288# One way to determine this is by running the following commands:
1289#
1290# @CODE
1071# strings <pdv archive> | grep lseek 1291# strings <pdv archive> | grep lseek
1072# strace -elseek <pdv archive> 1292# strace -elseek <pdv archive>
1293# @CODE
1294#
1073# basically look for the first lseek command (we do the strings/grep because 1295# Basically look for the first lseek command (we do the strings/grep because
1074# sometimes the function call is _llseek or something) and steal the 2nd 1296# sometimes the function call is _llseek or something) and steal the 2nd
1075# parameter. here is an example: 1297# parameter. Here is an example:
1298#
1299# @CODE
1076# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek 1300# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1077# lseek 1301# lseek
1078# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 1302# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1079# lseek(3, -4, SEEK_END) = 2981250 1303# lseek(3, -4, SEEK_END) = 2981250
1304# @CODE
1305#
1080# thus we would pass in the value of '4' as the second parameter. 1306# Thus we would pass in the value of '4' as the second parameter.
1081unpack_pdv() { 1307unpack_pdv() {
1082 local src=$(find_unpackable_file "$1") 1308 local src=$(find_unpackable_file "$1")
1083 local sizeoff_t=$2 1309 local sizeoff_t=$2
1084 1310
1085 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1311 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1147 true 1373 true
1148 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1374 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1149 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1375 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1150} 1376}
1151 1377
1378# @FUNCTION: unpack_makeself
1379# @USAGE: [file to unpack] [offset] [tail|dd]
1380# @DESCRIPTION:
1152# Unpack those pesky makeself generated files ... 1381# Unpack those pesky makeself generated files ...
1153# They're shell scripts with the binary package tagged onto 1382# They're shell scripts with the binary package tagged onto
1154# the end of the archive. Loki utilized the format as does 1383# the end of the archive. Loki utilized the format as does
1155# many other game companies. 1384# many other game companies.
1156# 1385#
1157# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1386# If the file is not specified, then ${A} is used. If the
1158# - If the file is not specified then unpack will utilize ${A}.
1159# - If the offset is not specified then we will attempt to extract 1387# offset is not specified then we will attempt to extract
1160# the proper offset from the script itself. 1388# the proper offset from the script itself.
1161unpack_makeself() { 1389unpack_makeself() {
1162 local src_input=${1:-${A}} 1390 local src_input=${1:-${A}}
1163 local src=$(find_unpackable_file "${src_input}") 1391 local src=$(find_unpackable_file "${src_input}")
1164 local skip=$2 1392 local skip=$2
1165 local exe=$3 1393 local exe=$3
1167 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1395 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1168 1396
1169 local shrtsrc=$(basename "${src}") 1397 local shrtsrc=$(basename "${src}")
1170 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1398 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1171 if [[ -z ${skip} ]] ; then 1399 if [[ -z ${skip} ]] ; then
1172 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1400 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1173 local skip=0 1401 local skip=0
1174 exe=tail 1402 exe=tail
1175 case ${ver} in 1403 case ${ver} in
1176 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1404 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1177 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1405 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1179 2.0|2.0.1) 1407 2.0|2.0.1)
1180 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1408 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1181 ;; 1409 ;;
1182 2.1.1) 1410 2.1.1)
1183 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1411 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1184 let skip="skip + 1" 1412 (( skip++ ))
1185 ;; 1413 ;;
1186 2.1.2) 1414 2.1.2)
1187 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1415 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1188 let skip="skip + 1" 1416 (( skip++ ))
1189 ;; 1417 ;;
1190 2.1.3) 1418 2.1.3)
1191 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1419 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1192 let skip="skip + 1" 1420 (( skip++ ))
1193 ;; 1421 ;;
1194 2.1.4|2.1.5) 1422 2.1.4|2.1.5)
1195 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1423 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1196 skip=$(head -n ${skip} "${src}" | wc -c) 1424 skip=$(head -n ${skip} "${src}" | wc -c)
1197 exe="dd" 1425 exe="dd"
1206 esac 1434 esac
1207 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1435 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1208 fi 1436 fi
1209 case ${exe} in 1437 case ${exe} in
1210 tail) exe="tail -n +${skip} '${src}'";; 1438 tail) exe="tail -n +${skip} '${src}'";;
1211 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1439 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1212 *) die "makeself cant handle exe '${exe}'" 1440 *) die "makeself cant handle exe '${exe}'"
1213 esac 1441 esac
1214 1442
1215 # lets grab the first few bytes of the file to figure out what kind of archive it is 1443 # lets grab the first few bytes of the file to figure out what kind of archive it is
1216 local tmpfile=$(emktemp) 1444 local filetype tmpfile=$(emktemp)
1217 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1445 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1218 local filetype=$(file -b "${tmpfile}") 1446 filetype=$(file -b "${tmpfile}") || die
1219 case ${filetype} in 1447 case ${filetype} in
1220 *tar\ archive*) 1448 *tar\ archive*)
1221 eval ${exe} | tar --no-same-owner -xf - 1449 eval ${exe} | tar --no-same-owner -xf -
1222 ;; 1450 ;;
1223 bzip2*) 1451 bzip2*)
1235 ;; 1463 ;;
1236 esac 1464 esac
1237 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1465 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1238} 1466}
1239 1467
1468# @FUNCTION: check_license
1469# @USAGE: [license]
1470# @DESCRIPTION:
1240# Display a license for user to accept. 1471# Display a license for user to accept. If no license is
1241#
1242# Usage: check_license [license]
1243# - If the file is not specified then ${LICENSE} is used. 1472# specified, then ${LICENSE} is used.
1244check_license() { 1473check_license() {
1245 local lic=$1 1474 local lic=$1
1246 if [ -z "${lic}" ] ; then 1475 if [ -z "${lic}" ] ; then
1247 lic="${PORTDIR}/licenses/${LICENSE}" 1476 lic="${PORTDIR}/licenses/${LICENSE}"
1248 else 1477 else
1252 lic="${PWD}/${lic}" 1481 lic="${PWD}/${lic}"
1253 elif [ -e "${lic}" ] ; then 1482 elif [ -e "${lic}" ] ; then
1254 lic="${lic}" 1483 lic="${lic}"
1255 fi 1484 fi
1256 fi 1485 fi
1257 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1258 local l="`basename ${lic}`" 1486 local l="`basename ${lic}`"
1259 1487
1260 # here is where we check for the licenses the user already 1488 # here is where we check for the licenses the user already
1261 # accepted ... if we don't find a match, we make the user accept 1489 # accepted ... if we don't find a match, we make the user accept
1262 local shopts=$-
1263 local alic 1490 local alic
1264 set -o noglob #so that bash doesn't expand "*" 1491 eshopts_push -o noglob # so that bash doesn't expand "*"
1265 for alic in ${ACCEPT_LICENSE} ; do 1492 for alic in ${ACCEPT_LICENSE} ; do
1266 if [[ ${alic} == ${l} ]]; then 1493 if [[ ${alic} == ${l} ]]; then
1267 set +o noglob; set -${shopts} #reset old shell opts 1494 eshopts_pop
1268 return 0 1495 return 0
1269 fi 1496 fi
1270 done 1497 done
1271 set +o noglob; set -$shopts #reset old shell opts 1498 eshopts_pop
1499 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1272 1500
1273 local licmsg=$(emktemp) 1501 local licmsg=$(emktemp)
1274 cat <<-EOF > ${licmsg} 1502 cat <<-EOF > ${licmsg}
1275 ********************************************************** 1503 **********************************************************
1276 The following license outlines the terms of use of this 1504 The following license outlines the terms of use of this
1277 package. You MUST accept this license for installation to 1505 package. You MUST accept this license for installation to
1278 continue. When you are done viewing, hit 'q'. If you 1506 continue. When you are done viewing, hit 'q'. If you
1279 CTRL+C out of this, the install will not run! 1507 CTRL+C out of this, the install will not run!
1280 ********************************************************** 1508 **********************************************************
1281 1509
1282 EOF 1510 EOF
1283 cat ${lic} >> ${licmsg} 1511 cat ${lic} >> ${licmsg}
1284 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}" 1512 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1285 einfon "Do you accept the terms of this license (${l})? [yes/no] " 1513 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1286 read alic 1514 read alic
1294 die "Failed to accept license" 1522 die "Failed to accept license"
1295 ;; 1523 ;;
1296 esac 1524 esac
1297} 1525}
1298 1526
1527# @FUNCTION: cdrom_get_cds
1528# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1529# @DESCRIPTION:
1299# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 1530# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1300# the whole 'non-interactive' policy, but damnit I want CD support ! 1531# the whole 'non-interactive' policy, but damnit I want CD support !
1301# 1532#
1302# with these cdrom functions we handle all the user interaction and 1533# With these cdrom functions we handle all the user interaction and
1303# standardize everything. all you have to do is call cdrom_get_cds() 1534# standardize everything. All you have to do is call cdrom_get_cds()
1304# and when the function returns, you can assume that the cd has been 1535# and when the function returns, you can assume that the cd has been
1305# found at CDROM_ROOT. 1536# found at CDROM_ROOT.
1306# 1537#
1538# The function will attempt to locate a cd based upon a file that is on
1539# the cd. The more files you give this function, the more cds
1540# the cdrom functions will handle.
1541#
1307# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 1542# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1308# etc... if you want to give the cds better names, then just export 1543# etc... If you want to give the cds better names, then just export
1309# the appropriate CDROM_NAME variable before calling cdrom_get_cds(). 1544# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1310# - CDROM_NAME="fooie cd" - for when you only want 1 cd 1545# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1311# - CDROM_NAME_1="install cd" - for when you want more than 1 cd 1546# also use the CDROM_NAME_SET bash array.
1312# CDROM_NAME_2="data cd"
1313# - CDROM_NAME_SET=( "install cd" "data cd" ) - short hand for CDROM_NAME_#
1314# 1547#
1315# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 1548# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1316#
1317# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1318# - this will attempt to locate a cd based upon a file that is on
1319# the cd ... the more files you give this function, the more cds
1320# the cdrom functions will handle
1321cdrom_get_cds() { 1549cdrom_get_cds() {
1322 # first we figure out how many cds we're dealing with by 1550 # first we figure out how many cds we're dealing with by
1323 # the # of files they gave us 1551 # the # of files they gave us
1324 local cdcnt=0 1552 local cdcnt=0
1325 local f= 1553 local f=
1349 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1577 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1350 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1578 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1351 export CDROM_SET=-1 1579 export CDROM_SET=-1
1352 for f in ${CDROM_CHECK_1//:/ } ; do 1580 for f in ${CDROM_CHECK_1//:/ } ; do
1353 ((++CDROM_SET)) 1581 ((++CDROM_SET))
1354 [[ -e ${CD_ROOT}/${f} ]] && break 1582 [[ -e ${CDROM_ROOT}/${f} ]] && break
1355 done 1583 done
1356 export CDROM_MATCH=${f} 1584 export CDROM_MATCH=${f}
1357 return 1585 return
1358 fi 1586 fi
1359 1587
1411 export CDROM_SET="" 1639 export CDROM_SET=""
1412 export CDROM_CURRENT_CD=0 1640 export CDROM_CURRENT_CD=0
1413 cdrom_load_next_cd 1641 cdrom_load_next_cd
1414} 1642}
1415 1643
1416# this is only used when you need access to more than one cd. 1644# @FUNCTION: cdrom_load_next_cd
1417# when you have finished using the first cd, just call this function. 1645# @DESCRIPTION:
1418# when it returns, CDROM_ROOT will be pointing to the second cd. 1646# Some packages are so big they come on multiple CDs. When you're done reading
1419# remember, you can only go forward in the cd chain, you can't go back. 1647# files off a CD and want access to the next one, just call this function.
1648# Again, all the messy details of user interaction are taken care of for you.
1649# Once this returns, just read the variable CDROM_ROOT for the location of the
1650# mounted CD. Note that you can only go forward in the CD list, so make sure
1651# you only call this function when you're done using the current CD.
1420cdrom_load_next_cd() { 1652cdrom_load_next_cd() {
1421 local var 1653 local var
1422 ((++CDROM_CURRENT_CD)) 1654 ((++CDROM_CURRENT_CD))
1423 1655
1424 unset CDROM_ROOT 1656 unset CDROM_ROOT
1441# displayed and we'll hang out here until: 1673# displayed and we'll hang out here until:
1442# (1) the file is found on a mounted cdrom 1674# (1) the file is found on a mounted cdrom
1443# (2) the user hits CTRL+C 1675# (2) the user hits CTRL+C
1444_cdrom_locate_file_on_cd() { 1676_cdrom_locate_file_on_cd() {
1445 local mline="" 1677 local mline=""
1446 local showedmsg=0 1678 local showedmsg=0 showjolietmsg=0
1447 1679
1448 while [[ -z ${CDROM_ROOT} ]] ; do 1680 while [[ -z ${CDROM_ROOT} ]] ; do
1449 local i=0 1681 local i=0
1450 local -a cdset=(${*//:/ }) 1682 local -a cdset=(${*//:/ })
1451 if [[ -n ${CDROM_SET} ]] ; then 1683 if [[ -n ${CDROM_SET} ]] ; then
1456 local dir=$(dirname ${cdset[${i}]}) 1688 local dir=$(dirname ${cdset[${i}]})
1457 local file=$(basename ${cdset[${i}]}) 1689 local file=$(basename ${cdset[${i}]})
1458 1690
1459 local point= node= fs= foo= 1691 local point= node= fs= foo=
1460 while read point node fs foo ; do 1692 while read point node fs foo ; do
1461 [[ " cd9660 iso9660 " != *" ${fs} "* ]] && \ 1693 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1462 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \ 1694 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1463 && continue 1695 && continue
1464 point=${point//\040/ } 1696 point=${point//\040/ }
1697 [[ ! -d ${point}/${dir} ]] && continue
1465 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue 1698 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1466 export CDROM_ROOT=${point} 1699 export CDROM_ROOT=${point}
1467 export CDROM_SET=${i} 1700 export CDROM_SET=${i}
1468 export CDROM_MATCH=${cdset[${i}]} 1701 export CDROM_MATCH=${cdset[${i}]}
1469 return 1702 return
1491 showedmsg=1 1724 showedmsg=1
1492 fi 1725 fi
1493 einfo "Press return to scan for the cd again" 1726 einfo "Press return to scan for the cd again"
1494 einfo "or hit CTRL+C to abort the emerge." 1727 einfo "or hit CTRL+C to abort the emerge."
1495 echo 1728 echo
1729 if [[ ${showjolietmsg} -eq 0 ]] ; then
1730 showjolietmsg=1
1731 else
1496 einfo "If you are having trouble with the detection" 1732 ewarn "If you are having trouble with the detection"
1497 einfo "of your CD, it is possible that you do not have" 1733 ewarn "of your CD, it is possible that you do not have"
1498 einfo "Joliet support enabled in your kernel. Please" 1734 ewarn "Joliet support enabled in your kernel. Please"
1499 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1735 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1736 ebeep 5
1737 fi
1500 read || die "something is screwed with your system" 1738 read || die "something is screwed with your system"
1501 done 1739 done
1502} 1740}
1503 1741
1742# @FUNCTION: strip-linguas
1743# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1744# @DESCRIPTION:
1504# Make sure that LINGUAS only contains languages that 1745# Make sure that LINGUAS only contains languages that
1505# a package can support 1746# a package can support. The first form allows you to
1506# 1747# specify a list of LINGUAS. The -i builds a list of po
1507# usage: strip-linguas <allow LINGUAS> 1748# files found in all the directories and uses the
1508# strip-linguas -i <directories of .po files> 1749# intersection of the lists. The -u builds a list of po
1509# strip-linguas -u <directories of .po files> 1750# files found in all the directories and uses the union
1510# 1751# of the lists.
1511# The first form allows you to specify a list of LINGUAS.
1512# The -i builds a list of po files found in all the
1513# directories and uses the intersection of the lists.
1514# The -u builds a list of po files found in all the
1515# directories and uses the union of the lists.
1516strip-linguas() { 1752strip-linguas() {
1517 local ls newls nols 1753 local ls newls nols
1518 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1754 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1519 local op=$1; shift 1755 local op=$1; shift
1520 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1756 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1521 local d f 1757 local d f
1522 for d in "$@" ; do 1758 for d in "$@" ; do
1523 if [[ ${op} == "-u" ]] ; then 1759 if [[ ${op} == "-u" ]] ; then
1524 newls=${ls} 1760 newls=${ls}
1525 else 1761 else
1526 newls="" 1762 newls=""
1527 fi 1763 fi
1528 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1764 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1529 if [[ ${op} == "-i" ]] ; then 1765 if [[ ${op} == "-i" ]] ; then
1530 hasq ${f} ${ls} && newls="${newls} ${f}" 1766 has ${f} ${ls} && newls="${newls} ${f}"
1531 else 1767 else
1532 hasq ${f} ${ls} || newls="${newls} ${f}" 1768 has ${f} ${ls} || newls="${newls} ${f}"
1533 fi 1769 fi
1534 done 1770 done
1535 ls=${newls} 1771 ls=${newls}
1536 done 1772 done
1537 else 1773 else
1539 fi 1775 fi
1540 1776
1541 nols="" 1777 nols=""
1542 newls="" 1778 newls=""
1543 for f in ${LINGUAS} ; do 1779 for f in ${LINGUAS} ; do
1544 if hasq ${f} ${ls} ; then 1780 if has ${f} ${ls} ; then
1545 newls="${newls} ${f}" 1781 newls="${newls} ${f}"
1546 else 1782 else
1547 nols="${nols} ${f}" 1783 nols="${nols} ${f}"
1548 fi 1784 fi
1549 done 1785 done
1550 [[ -n ${nols} ]] \ 1786 [[ -n ${nols} ]] \
1551 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1787 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1552 export LINGUAS=${newls:1} 1788 export LINGUAS=${newls:1}
1553} 1789}
1554 1790
1555# moved from kernel.eclass since they are generally useful outside of 1791# @FUNCTION: preserve_old_lib
1556# kernel.eclass -iggy (20041002) 1792# @USAGE: <libs to preserve> [more libs]
1557 1793# @DESCRIPTION:
1558# the following functions are useful in kernel module ebuilds, etc.
1559# for an example see ivtv or drbd ebuilds
1560
1561# set's ARCH to match what the kernel expects
1562set_arch_to_kernel() {
1563 i=10
1564 while ((i--)) ; do
1565 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1566 done
1567 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1568 case ${ARCH} in
1569 x86) export ARCH="i386";;
1570 amd64) export ARCH="x86_64";;
1571 hppa) export ARCH="parisc";;
1572 mips) export ARCH="mips";;
1573 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1574 *) export ARCH="${ARCH}";;
1575 esac
1576}
1577
1578# set's ARCH back to what portage expects
1579set_arch_to_portage() {
1580 i=10
1581 while ((i--)) ; do
1582 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1583 done
1584 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1585}
1586
1587# Jeremy Huddleston <eradicator@gentoo.org>:
1588# preserve_old_lib /path/to/libblah.so.0
1589# preserve_old_lib_notify /path/to/libblah.so.0
1590#
1591# These functions are useful when a lib in your package changes --library. Such 1794# These functions are useful when a lib in your package changes ABI SONAME.
1592# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1795# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1593# would break packages that link against it. Most people get around this 1796# would break packages that link against it. Most people get around this
1594# by using the portage SLOT mechanism, but that is not always a relevant 1797# by using the portage SLOT mechanism, but that is not always a relevant
1595# solution, so instead you can add the following to your ebuilds: 1798# solution, so instead you can call this from pkg_preinst. See also the
1596# 1799# preserve_old_lib_notify function.
1597# pkg_preinst() {
1598# ...
1599# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1600# ...
1601# }
1602#
1603# pkg_postinst() {
1604# ...
1605# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1606# ...
1607# }
1608
1609preserve_old_lib() { 1800preserve_old_lib() {
1610 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then 1801 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1611 eerror "preserve_old_lib() must be called from pkg_preinst() only" 1802 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1612 die "Invalid preserve_old_lib() usage" 1803 die "Invalid preserve_old_lib() usage"
1613 fi 1804 fi
1614 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]" 1805 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1806
1807 # let portage worry about it
1808 has preserve-libs ${FEATURES} && return 0
1615 1809
1616 local lib dir 1810 local lib dir
1617 for lib in "$@" ; do 1811 for lib in "$@" ; do
1618 [[ -e ${ROOT}/${lib} ]] || continue 1812 [[ -e ${ROOT}/${lib} ]] || continue
1619 dir=${lib%/*} 1813 dir=${lib%/*}
1621 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed" 1815 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1622 touch "${D}"/${lib} 1816 touch "${D}"/${lib}
1623 done 1817 done
1624} 1818}
1625 1819
1820# @FUNCTION: preserve_old_lib_notify
1821# @USAGE: <libs to notify> [more libs]
1822# @DESCRIPTION:
1823# Spit helpful messages about the libraries preserved by preserve_old_lib.
1626preserve_old_lib_notify() { 1824preserve_old_lib_notify() {
1627 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then 1825 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1628 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only" 1826 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1629 die "Invalid preserve_old_lib_notify() usage" 1827 die "Invalid preserve_old_lib_notify() usage"
1630 fi 1828 fi
1829
1830 # let portage worry about it
1831 has preserve-libs ${FEATURES} && return 0
1631 1832
1632 local lib notice=0 1833 local lib notice=0
1633 for lib in "$@" ; do 1834 for lib in "$@" ; do
1634 [[ -e ${ROOT}/${lib} ]] || continue 1835 [[ -e ${ROOT}/${lib} ]] || continue
1635 if [[ ${notice} -eq 0 ]] ; then 1836 if [[ ${notice} -eq 0 ]] ; then
1639 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1840 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1640 ewarn "in order to remove these old dependencies. If you do not have this" 1841 ewarn "in order to remove these old dependencies. If you do not have this"
1641 ewarn "helper program, simply emerge the 'gentoolkit' package." 1842 ewarn "helper program, simply emerge the 'gentoolkit' package."
1642 ewarn 1843 ewarn
1643 fi 1844 fi
1845 # temp hack for #348634 #357225
1846 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1644 ewarn " # revdep-rebuild --library ${lib##*/}" 1847 ewarn " # revdep-rebuild --library '${lib}'"
1645 done 1848 done
1849 if [[ ${notice} -eq 1 ]] ; then
1850 ewarn
1851 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1852 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1853 for lib in "$@" ; do
1854 ewarn " # rm '${lib}'"
1855 done
1856 fi
1646} 1857}
1647 1858
1648# Hack for people to figure out if a package was built with 1859# @FUNCTION: built_with_use
1649# certain USE flags
1650#
1651# Usage: built_with_use [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1860# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1652# ex: built_with_use xchat gtk2 1861# @DESCRIPTION:
1653# 1862#
1654# Flags: -a all USE flags should be utilized 1863# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1655# -o at least one USE flag should be utilized 1864#
1656# --missing peform the specified action if the flag is not in IUSE (true/false/die) 1865# A temporary hack until portage properly supports DEPENDing on USE
1657# --hidden USE flag we're checking is hidden expanded so it isnt in IUSE 1866# flags being enabled in packages. This will check to see if the specified
1658# Note: the default flag is '-a' 1867# DEPEND atom was built with the specified list of USE flags. The
1868# --missing option controls the behavior if called on a package that does
1869# not actually support the defined USE flags (aka listed in IUSE).
1870# The default is to abort (call die). The -a and -o flags control
1871# the requirements of the USE flags. They correspond to "and" and "or"
1872# logic. So the -a flag means all listed USE flags must be enabled
1873# while the -o flag means at least one of the listed IUSE flags must be
1874# enabled. The --hidden option is really for internal use only as it
1875# means the USE flag we're checking is hidden expanded, so it won't be found
1876# in IUSE like normal USE flags.
1877#
1878# Remember that this function isn't terribly intelligent so order of optional
1879# flags matter.
1659built_with_use() { 1880built_with_use() {
1660 local hidden="no" 1881 local hidden="no"
1661 if [[ $1 == "--hidden" ]] ; then 1882 if [[ $1 == "--hidden" ]] ; then
1662 hidden="yes" 1883 hidden="yes"
1663 shift 1884 shift
1692 die) die "Unable to determine what USE flags $PKG was built with";; 1913 die) die "Unable to determine what USE flags $PKG was built with";;
1693 esac 1914 esac
1694 fi 1915 fi
1695 1916
1696 if [[ ${hidden} == "no" ]] ; then 1917 if [[ ${hidden} == "no" ]] ; then
1697 local IUSE_BUILT=$(<${IUSEFILE}) 1918 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1698 # Don't check USE_EXPAND #147237 1919 # Don't check USE_EXPAND #147237
1699 local expand 1920 local expand
1700 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do 1921 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1701 if [[ $1 == ${expand}_* ]] ; then 1922 if [[ $1 == ${expand}_* ]] ; then
1702 expand="" 1923 expand=""
1703 break 1924 break
1704 fi 1925 fi
1705 done 1926 done
1706 if [[ -n ${expand} ]] ; then 1927 if [[ -n ${expand} ]] ; then
1707 if ! has $1 ${IUSE_BUILT} ; then 1928 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1708 case ${missing_action} in 1929 case ${missing_action} in
1709 true) return 0;; 1930 true) return 0;;
1710 false) return 1;; 1931 false) return 1;;
1711 die) die "$PKG does not actually support the $1 USE flag!";; 1932 die) die "$PKG does not actually support the $1 USE flag!";;
1712 esac 1933 esac
1724 shift 1945 shift
1725 done 1946 done
1726 [[ ${opt} = "-a" ]] 1947 [[ ${opt} = "-a" ]]
1727} 1948}
1728 1949
1950# @FUNCTION: epunt_cxx
1951# @USAGE: [dir to scan]
1952# @DESCRIPTION:
1729# Many configure scripts wrongly bail when a C++ compiler 1953# Many configure scripts wrongly bail when a C++ compiler could not be
1730# could not be detected. #73450 1954# detected. If dir is not specified, then it defaults to ${S}.
1955#
1956# http://bugs.gentoo.org/73450
1731epunt_cxx() { 1957epunt_cxx() {
1732 local dir=$1 1958 local dir=$1
1733 [[ -z ${dir} ]] && dir=${S} 1959 [[ -z ${dir} ]] && dir=${S}
1734 ebegin "Removing useless C++ checks" 1960 ebegin "Removing useless C++ checks"
1735 local f 1961 local f
1736 for f in $(find ${dir} -name configure) ; do 1962 find "${dir}" -name configure | while read f ; do
1737 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1963 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1738 done 1964 done
1739 eend 0 1965 eend 0
1740} 1966}
1741 1967
1742# make a wrapper script ... 1968# @FUNCTION: make_wrapper
1743# NOTE: this was originally games_make_wrapper, but I noticed other places where 1969# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1744# this could be used, so I have moved it here and made it not games-specific 1970# @DESCRIPTION:
1745# -- wolf31o2 1971# Create a shell wrapper script named wrapper in installpath
1746# $1 == wrapper name 1972# (defaults to the bindir) to execute target (default of wrapper) by
1747# $2 == binary to run 1973# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1748# $3 == directory to chdir before running binary 1974# libpaths followed by optionally changing directory to chdir.
1749# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1750# $5 == path for wrapper
1751make_wrapper() { 1975make_wrapper() {
1752 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1976 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1753 local tmpwrapper=$(emktemp) 1977 local tmpwrapper=$(emktemp)
1754 # We don't want to quote ${bin} so that people can pass complex 1978 # We don't want to quote ${bin} so that people can pass complex
1755 # things as $bin ... "./someprog --args" 1979 # things as $bin ... "./someprog --args"
1765fi 1989fi
1766exec ${bin} "\$@" 1990exec ${bin} "\$@"
1767EOF 1991EOF
1768 chmod go+rx "${tmpwrapper}" 1992 chmod go+rx "${tmpwrapper}"
1769 if [[ -n ${path} ]] ; then 1993 if [[ -n ${path} ]] ; then
1994 (
1770 exeinto "${path}" 1995 exeinto "${path}"
1771 newexe "${tmpwrapper}" "${wrapper}" 1996 newexe "${tmpwrapper}" "${wrapper}"
1997 ) || die
1772 else 1998 else
1773 newbin "${tmpwrapper}" "${wrapper}" 1999 newbin "${tmpwrapper}" "${wrapper}" || die
1774 fi 2000 fi
1775} 2001}
2002
2003# @FUNCTION: path_exists
2004# @USAGE: [-a|-o] <paths>
2005# @DESCRIPTION:
2006# Check if the specified paths exist. Works for all types of paths
2007# (files/dirs/etc...). The -a and -o flags control the requirements
2008# of the paths. They correspond to "and" and "or" logic. So the -a
2009# flag means all the paths must exist while the -o flag means at least
2010# one of the paths must exist. The default behavior is "and". If no
2011# paths are specified, then the return value is "false".
2012path_exists() {
2013 local opt=$1
2014 [[ ${opt} == -[ao] ]] && shift || opt="-a"
2015
2016 # no paths -> return false
2017 # same behavior as: [[ -e "" ]]
2018 [[ $# -eq 0 ]] && return 1
2019
2020 local p r=0
2021 for p in "$@" ; do
2022 [[ -e ${p} ]]
2023 : $(( r += $? ))
2024 done
2025
2026 case ${opt} in
2027 -a) return $(( r != 0 )) ;;
2028 -o) return $(( r == $# )) ;;
2029 esac
2030}

Legend:
Removed from v.1.277  
changed lines
  Added in v.1.363

  ViewVC Help
Powered by ViewVC 1.1.20